﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace HeuristicLab.Hive.Experiment {
  public class Progress : IProgress {
    private string status;
    public string Status {
      get {
        return this.status;
      }
      set {
        if (this.status != value) {
          this.status = value;
          OnStatusChanged();
        }
      }
    }

    private double progressValue;
    public double ProgressValue {
      get {
        return this.progressValue;
      }
      set {
        if (this.progressValue != value) {
          this.progressValue = value;
          OnProgressChanged();
        }
      }
    }

    public Progress() { }

    public Progress(string status) {
      this.Status = status;
    }

    public void Finish() {
      OnFinished();
    }

    #region Event Handler
    public event EventHandler Finished;
    private void OnFinished() {
      var handler = Finished;
      if (handler != null) handler(this, EventArgs.Empty);
    }

    public event EventHandler StatusChanged;
    private void OnStatusChanged() {
      var handler = StatusChanged;
      if (handler != null) handler(this, EventArgs.Empty);
    }

    public event EventHandler ProgressValueChanged;
    private void OnProgressChanged() {
      var handler = ProgressValueChanged;
      if (handler != null) handler(this, EventArgs.Empty);
    }
    #endregion
  }
}
